#include <signal.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#define pathtar "/bin/tar"   // path tar
#define pathmake "/usr/bin/make" //path make
#define pathbc "/usr/bin/bc"   // path bc

/*#define WARNING 1
#define ERROR 2
#define NADA 0
*/


/* comptest() busca warnings y errores
 * en la compilacion. Luego arroja como
 * resultado si estamos frente a un caso 
 * de WARNING o ERROR. En caso de no ser 
 * ninguno de los 2, retorna NADA.
 */
/*
int comptest(char *s_test)
{
    char *warning = "warni";
    char *aviso = "aviso";
    char *error = "error";
    char temp[5];
    int i,j;
    printf("string stest: %s", s_test);
    for (i = 0; i < strlen(s_test)-6; i++)
    {
        for (j = 0; j < 5; j++)
             temp[j] = s_test[i+j];
        printf("string temporal: %s", temp);
        if (strncmp(s_test, warning, 5)!=0 || strncmp(s_test, aviso, 5)!=0)
             return WARNING;
        if (strncmp(s_test, error, 5)!=0)
             return ERROR;
    }
   return NADA;
}


*/






/* getln() toma un string y lo copia en
 * otro hasta encontrar \n,usado para 
 * obtener directiorios.
 */

char *getln(char *string1, char *string2)
{
   int i, count = 1;
   
   for (i=0; i<=(int)strlen(string2); i++)
     {
	
	if(string2[i]=='\n')
	  break;
	else
	  count++;
     }
  
   string1 = (char *)malloc((count+3)*sizeof(char));
   strncpy(string1, string2, count-1);
   return string1;
}

/* getln2() toma un string y lo copia en
 * otro hasta encontrar \n, en este caso 
 * incluye ademas el retorno de linea
 */


char *getln2(char *string1, char *string2)
{
   int i, count = 1;
   for (i=0; i<=(int)strlen(string2); i++)
     {
	
	if(string2[i]=='\n')
	  break;
	else
	  count++;
     }

   string1 = (char *)malloc((count+2)*sizeof(char));
   strncpy(string1, string2, count);
   return string1;
}

/* strcpypat() toma un string que contiene
 * el path de ejecucion y le agrega la ruta 
 * relativa al directorio paterno y el archivo
 * ra que se usa en execl EJ: ./<string2>/ra
 */



char *strcpypat  (char *string2 )
{
        int i;
       
        int size = (int)strlen(string2)+5;
        char *string1;
        
        string1 = (char *)malloc(size*sizeof(char));
         
        string1[0] = '.';
        string1[1] = '/';
 
        
        for (i = 2; i <= size-2; i++)
        {
	   
             string1[i] = string2[i-2];
             //printf("i = %d  string1 = %c\n",i, string1[i] );
	}
        string1[size-3]= 'r';
        string1[size-2]= 'a';
        
        // printf("\npaterno %s\n", string1);
        return string1;
        
}


int main (int argc, char *argv[])
{
        int tpo_respuesta = 3; // tiempo que se demora el programa en contestar
	int timeout=5;
        int expr_num;
	int correctas=0,total=0,tiempo=0,simtimeout=4;
	int i, j,status,lapso;
        int warn_count = 0, err_count = 0;

        char result[15][1024];


	int tar_in[2],tar_out[2];
        int make_in[2], make_out[2];
	int bc_in[2], bc_out[2];
        int ra_in[2], ra_out[2];
   

        char *warning = "warni";
        char *aviso = "aviso";
        char *error = "error";
        char temp[5];


	char inbuf[1024];
	char lectmp[200];
	char respuesta[1024];
        char respuesta2[1024];
	FILE *expr;
	FILE *bc;
	FILE *tmp;
	pid_t pid;
	
        void *path;
        char *archivo_expr;  
   
	printf("Revision Automatica de Tareas\nAutores: Juan Pablo Lorca  / Diego del Valle \n");
	if (argc<3 || argc>4 || (argc==4 && atoi(argv[3])<1))
	{
	    printf("La sintaxis es: rat solucion archivo_problemas [timeout]\n\n");
	    printf("donde: solucion es el archivo.tar.gz que contiene la solucion del alumno");
	    printf("y: archivo_problemas es un archivo de texto que contiene ");
	    printf("en cada linea una de las\n expresiones a evaluar\n");
	    printf("-timeout es un parametro que indica el tiempo ");
	    printf("maximo de espera\n por una respuesta (minimo 1 segundo)\n\n");
	    exit(1);
	}

        if (argc == 4) timeout = atoi(argv[3]);

	if ((expr=fopen(pathtar,"r"))==NULL)
	{
	    printf("\nLa aplicacion tar no se encuentra en el directorio ");
	    printf(pathtar);
	    printf("\n\nNecesita recompilar modificando la cuarta linea del\n");
	    printf("archivo rat.c para que se ajuste a su maquina\n\n");
	    exit(1);
	}
	fclose(expr);
	
        //if (argc==4) timeout=atoi(argv[3]);
	//printf("Timeout: %d segundos\n",timeout);

	if ((expr=fopen(argv[2],"r"))==NULL)
	{
	    fprintf(stderr,"No se puede abrir el archivo de expresiones! (%s)\n\n",argv[2]);
	    exit(1);
	}
   
        expr_num = (int)strlen(argv[2])+3;

        archivo_expr = (char *) malloc((size_t)expr_num*sizeof(char));

        printf("Revision de Tarea <%s>\n", argv[1]);       
        printf("Archivo de Expresiones <%s>\n", argv[2]);
        printf("Timeout <%d> segundos\n",timeout);
        printf("Timepo de respuesta <%d> segundos\n", tpo_respuesta);

/* Inicio Seccion Tar:
 *   En esta seccion se invoca a tar con pipas
 * con el fin de saber en que directorio quedan
 * los archivos descomprimidos
 */
        
        if (pipe(tar_in)<0) // Pipe de entrada a tar (Expresiones)
	{
	    perror("Pipe de Expresiones de Tar");
	    exit(1);
        }

        if (pipe(tar_out)<0) // Pipe de salida desde tar (Resultados)
	{
	    perror("Pipe de Resultados de Tar");
	    exit(1);
        }


         
	if ((pid=fork())<0)
	{
	    perror("Fork!");
	    exit(1);
	}
	
	if (pid==0)
	{
	    dup2(tar_out[1],1); // Asociar stdout a esta pipe
	    dup2(tar_in[0],0); // Asociar stdin a esta pipe
	    close(tar_out[0]); // No leeremos de esta pipe
	    close(tar_in[1]); // No escribiremos en esta pipe
	    execl(pathtar,"tar","-xvzf", argv[1] ,0);
	    exit(0);
    	}
        close(tar_out[1]); // No escribiremos en esta pipe
	close(tar_in[0]); // No leeremos de esta pipe
	waitpid(pid, &status, 0); //esperamos que termine tar
        read(tar_out[0],respuesta,1024);
        
        path = (char *)getln(path, respuesta); 
        // strncpy(path, getln(path, respuesta));
        //printf("path: %s\n", path);
        close(tar_in[0]);
	close(tar_in[1]);	
	close(tar_out[0]);
	close(tar_out[1]);   
        waitpid(pid, &status,0);


/////////////////////
// Fin Seccion tar //
/////////////////////


/* Inicio Seccion Compilacion
 *   En esta seccion se invoca a make con pipas
 * con el fin de obtener los errores y warnings
 * en el momento de compilacion, para evaluar
 * el codigo ingresado.
 */ 
        
        printf("\nCompilacion:\n");   

        if (pipe(make_in)<0) // Pipe de entrada a Make (Expresiones)
	{
	    perror("Pipe de Expresiones de Make");
	    exit(1);
        }

        if (pipe(make_out)<0) // Pipe de salida desde make (Resultados)
	{
	    perror("Pipe de Resultados de Make");
	    exit(1);
        }
         

	if ((pid=fork())<0)
	{
	    perror("Fork!");
	    exit(1);
	}
	
	if (pid==0)
	{
	    dup2(make_out[1],2); // Asociar salida de error a esta pipe
            dup2(make_out[1],1); // Asociar stdout a esta pipe
	    dup2(make_in[0],0); // Asociar stdin a esta pipe
	    close(make_out[0]); // No leeremos de esta pipe
	    close(make_in[1]); // No escribiremos en esta pipe
	    execl(pathmake,"make","-C", path, 0);
	    exit(0);
    	}
        close(make_out[1]); // No escribiremos en esta pipe
	close(make_in[0]); // No leeremos de esta pipe
	waitpid(pid, &status, 0); //esperamos que termine tar
        read(make_out[0],respuesta,1024);
        
        //printf("Reporte de errores: \n %s\n", respuesta);

 

        
             
        for (i = 0; i < strlen(respuesta)-5; i++)
        {
            for (j = 0; j < 5; j++)
                  temp[j] = respuesta[i+j];
            
            if (strcmp(temp, warning)==0 || strcmp(temp, aviso)==0)
                  warn_count++;
            if (strcmp(temp, error)==0)
                  err_count++;
   
        }
        
        printf("\nwarn %d, err %d\n", warn_count, err_count);
        if (warn_count+err_count>0)
              printf("Hubo warnings o fallas en la compilacion\n");
        else
              printf("Compilacion OK!! \n");

 
        close(make_in[0]);
	close(make_in[1]);	
	close(make_out[0]);
	close(make_out[1]);   
        waitpid(pid, &status,0);




//////////////////////////////
// Fin Seccion Compilacion //
/////////////////////////////


/* Inicio Seccion Respuesta 
 *   La idea de este modulo es obtener los resultados
 * de las expresiones a priori, para luego comparalas
 * con el metodo usado en la funcion ra dada en el 
 * archivo de solucion
 */  

        printf("\nEjecucion:\n"); 
          


        if (pipe(bc_in)<0) // Pipe de entrada a bc (Expresiones)
	{
	    perror("Pipe de Expresiones");
	    exit(1);
        }

        if (pipe(bc_out)<0) // Pipe de salida desde bc (Resultados)
	{
	    perror("Pipe de Resultados");
	    exit(1);
        }
	if ((pid=fork())<0)
	{
	    perror("Fork!");
	    exit(1);
	}

	if (pid==0)
	{
	    dup2(bc_out[1],1); // Asociar stdout a esta pipe
	    dup2(bc_in[0],0); // Asociar stdin a esta pipe
	    close(bc_out[0]); // No leeremos de esta pipe
	    close(bc_in[1]); // No escribiremos en esta pipe
	    execl(pathbc,"bc","-q",0);
	    exit(0);
    	}
        close(bc_out[1]); // No escribiremos en esta pipe
	close(bc_in[0]); // No leeremos de esta pipe

        total=0;
      
        
	while(fgets(lectmp,200,expr)!=NULL)
	{
	   
       
	    write(bc_in[1],lectmp,strlen(lectmp)); // entrega expresion a bc
         
	    if (read(bc_out[0],respuesta,1024)<0) // lee respuesta desde bc
		{
		    perror("Respuesta");
                }
            strcpy(result[total], getln2(result[total], respuesta));
            
            //printf("result[%d] %s\n",total, result[total]);

            //strcpy(result[total],respuesta);
            
		
	    // printf("lectmp: %s, result[%d]: %s\n",lectmp, total, result[total]);
            total++;	

	
	   
	}
	write(bc_in[1],"quit\n",5); // cierra el bc

        
	
	close(bc_in[0]);
	close(bc_in[1]);	
	close(bc_out[0]);
	close(bc_out[1]);
	waitpid(pid,&status, 0); // espera a que se cierre el bc


////////////////////////////
// Fin Seccion Respuesta //
//////////////////////////


/* Inicio Seccion Ejecucion 
 *   En esta seccion se pondra a prueba el codigo 
 * de solucion al problema, comparando los resultados
 * con los ya conocidos y evaluando si cumple con
 * los objetivos propuestos en el problema.
 */  


        if (pipe(ra_in)<0) // Pipe de entrada a ra (Expresiones)
	{
	    perror("Pipe de Expresiones");
	    exit(1);
        }

        if (pipe(ra_out)<0) // Pipe de salida desde ra (Resultados)
	{
	    perror("Pipe de Resultados");
	    exit(1);
        }

        path = strcpypat(path);
        // printf("%s\n", path);

	if ((pid=fork())<0)
	{
	    perror("Fork!");
	    exit(1);
	}
	

	if (pid==0)
	{
            // printf("EJECUCION DE RA\n");
            fflush(stdout);  
	    dup2(ra_out[1],1); // Asociar stdout a esta pipe // COMENTAR PARA VER RESULTADO EN PANTALLA
	    dup2(ra_in[0],0); // Asociar stdin a esta pipe
	    close(ra_out[0]); // No leeremos de esta pipe
	    close(ra_in[1]); // No escribiremos en esta pipe
	    execl(path,"ra",argv[2], argv[3] ,0);
	    exit(0);
    	}
        close(ra_out[1]); // No escribiremos en esta pipe
	close(ra_in[0]); // No leeremos de esta pipe

        printf("Numero de Expresiones a Evaluar = %d\n\n", total);
        for(i=0; i<=total-1; i++)
        {
            printf("Expresion %d\t", i+1);
            printf("La respuesta esperada es: %s", result[i]);            
            
            sleep(tpo_respuesta);
	    write(ra_in[1], result[i] ,strlen(result[i])); // entrega resultado expresion a ra
	    //printf("iteracion %d\ndato enviado: %s\n ",i,result[i]);
	    
        }
        if (tpo_respuesta<timeout) 
            {
               printf("\nRespuestas correntas Ra debe arrojar: %d de 3\n", total);
               printf("\nTiempo promedio de respuestas: %d segundos\n", tpo_respuesta);
            }
        else
            {
               printf("\nRespuestas correntas Ra debe arrojar: 0 de 3\n");
               printf("\nTiempo promedio de respuestas: %d segundos\n", timeout);
            }


        write(ra_in[1],"quit\n",5); // cierra el ra
        read(ra_out[0],respuesta2,1024);    
        printf("\nLas Respuestas de la tarea en revision son: \n"); 
        printf("====================================================\n\n %s\n\n", respuesta2);


        printf("====================================================\n\n", respuesta2);



        fclose(expr);
        
	close(ra_in[0]);
	close(ra_in[1]);	
	close(ra_out[0]);
	close(ra_out[1]);
        waitpid(pid,NULL, 0); // espera a que se cierre proceso hijo ra
        printf("FIN\n");
	return 0;
}
